// Generated by CoffeeScript 1.6.2
(function() {
  var PluginManager, async, data, divider, formatRecs, fs, groupedRecords, outputFolder, path, plist, pluginManager, processAllLogs, util, yaml;

  fs = require('fs');

  path = require('path');

  yaml = require('js-yaml');

  util = require('util');

  plist = require('plist');

  async = require('async');

  require('sugar');

  PluginManager = require('../lib/plugin').PluginManager;

  data = yaml.load(fs.readFileSync(path.join(__dirname, 'unparsable_logs.yml'), 'utf8'));

  groupedRecords = Object.values(data.groupBy('compiler'));

  divider = "------------------------------------------------------------";

  outputFolder = path.join(__dirname, 'reports');

  formatRecs = function(recs) {
    return recs.map(function(r) {
      return ("" + (r.output || '') + "\n\n") + r.body.replace(/\s*$/, '') + "\n";
    }).join("\n" + divider + "\n\n");
  };

  processAllLogs = function(pluginManager, callback) {
    return async.forEach(groupedRecords, function(recs, callback) {
      var compiler, e, folderPath, messages, name;

      name = recs[0].compiler;
      compiler = pluginManager.compilers[name];
      folderPath = compiler.plugin.folder;
      try {
        messages = fs.readFileSync("" + folderPath + "/messages.txt", 'utf-8').split(divider).map(function(m) {
          return m.trim();
        });
      } catch (_error) {
        e = _error;
        messages = [];
      }
      return plist.parseFile("" + folderPath + "/Info.plist", function(err, obj) {
        var m, parsed, parser, rec, recsText, unparsed, _i, _len;

        if (err) {
          return callback(err);
        }
        parser = compiler.parser;
        recs = ((function() {
          var _i, _len, _results;

          _results = [];
          for (_i = 0, _len = messages.length; _i < _len; _i++) {
            m = messages[_i];
            _results.push({
              body: m
            });
          }
          return _results;
        })()).concat(recs);
        for (_i = 0, _len = recs.length; _i < _len; _i++) {
          rec = recs[_i];
          rec.output = parser.parse(rec.body);
          rec.matched = rec.output.parsed;
        }
        unparsed = recs.findAll(function(r) {
          return !r.matched;
        });
        parsed = recs.findAll(function(r) {
          return r.matched;
        });
        console.log(name, unparsed.length);
        recsText = recs.map(function(r) {
          return r.body.replace(/\s*$/, '') + "\n";
        }).join("\n" + divider + "\n\n");
        if (unparsed.length) {
          fs.writeFileSync("" + outputFolder + "/" + name + "-bad.txt", formatRecs(unparsed));
        } else {
          try {
            fs.unlinkSync("" + outputFolder + "/" + name + "-bad.txt");
          } catch (_error) {
            e = _error;
          }
        }
        fs.writeFileSync("" + outputFolder + "/" + name + "-ok.txt", formatRecs(parsed));
        fs.writeFileSync("" + outputFolder + "/" + name + "-formats.txt", JSON.stringify(parser.errorFormats.findAll(function(f) {
          return !f.used;
        }), null, 2));
        return callback();
      });
    }, function(err) {});
  };

  pluginManager = new PluginManager([path.join(__dirname, "../../LiveReload/Compilers")]);

  pluginManager.rescan(function(err) {
    return processAllLogs(pluginManager, function(err) {
      return console.log("DONE.");
    });
  });

}).call(this);
